# Scene Workspaces - Add-On

![Overview image](assets/Preview%20Image.png)

## Overview

**Scene Workspaces** creates an alternative workspaces topbar, allowing you to filter and reorder workspaces, scene by scene.  

Basically, you can decide which workspace you want to link to each scene.

> This is possible thanks to a custom property at scene level (which is saved with your .blend file).  
> *This property simply list names of the linked workspaces, in the correct order.*

---

You can customize Scene Workspaces from add-on preferences:

- **Show Switch**  
  *When active, shows a checkbox to switch between Scene Workspaces and the default topbar.*
![Compact Mode OFF](assets/Topbar%20-%20Switch.png)
*This checkbox will directly affect the next preference.*
- **Use Scene Workspaces topbar**  
*Scene Workspaces topbar.*  
![Compact Mode OFF](assets/Topbar%20-%20Custom.png)
*Default workspaces topbar.*  
![Compact Mode OFF](assets/Topbar%20-%20Original.png)
- **Use Compact Mode** *(default ON)*
*Compact Mode ON*
![Compact Mode OFF](assets/Topbar%20-%20Compact%20On.png)
*Compact Mode OFF*
![Compact Mode OFF](assets/Topbar%20-%20Compact%20Off.png)

---

What you can usually to do by right-clicking on a workspace (and more) it's avaliable by clicking the near options button.

![Compact Mode OFF](assets/Topbar%20-%20Workspace%20Menu.png)

The first options are the ones from Scene Workspaces:

- **Toggle Compact Mode** *(preference)*
- **Unlink workspace from scene**
- **Rename** *(for all scenes)*
- **Reorder to front** *(only for these scene)*
- **Move left** *(only for these scene)*
- **Move right** *(only for these scene)*
- **Reorder to back** *(only for these scene)*
- **Previous workspace** *(using scene order) `Shift + Ctrl + Page Up`*
- **Next Workspace** *(using scene order) `Shift + Ctrl + Page Down`*

And then, starting from `Duplicate`, you'll find the default workspace options.

> **Note**  
> Default options like `Reorder to Front`, `Reorder to Back` will only affect the global workspaces, and not the Scene Workspaces topbar.  
*Instead, use the ones marked with `(scene only)`.*  
>
> Also, default options `Previous Workspace` and `Next Workspace` functions will follow the global workspaces order, and not the scene order.  
*Instead, use the ones marked with `(scene)`.*  
> Be sure to use the Scene Workspaces relative options, instead.

---

You can link other workspaces to the current scene, using the menu with the workspace icon:

![Link other workspaces](assets/Topbar%20-%20Link%20other%20workspaces.png)

or by clicking the active workspace, if it's not currently linked

![Link other workspaces](assets/Topbar%20-%20Link%20current.png)

You can also copy the linked workspaces from another scene, using the menu with the duplicate icon:

![Link other workspaces](assets/Topbar%20-%20Copy%20from%20other%20scene.png)

---

## Why this add-on?

In Blender, workspaces are common across scenes.

Still, you may need different workspaces in different scenes, depending on the purpose of the scene.

*For example, you may want a scene with workspaces optimized for modelling and
another Scene optimized for Video Editing, in the same project.*

## Changelog

Visit the [CHANGELOG](./CHANGELOG.md) file to see the changes over new version.  

## Copyright

This add-on is developed under GPL-3.0 license by Francesco Bellini from 2024.  
*See the [LICENSE](./LICENSE) file.*
